
CoCoALib - Design #1225

Move to C++14 (skipping C++11)

06 Sep 2018 16:07 - John Abbott

Status: In Progress Start date: 06 Sep 2018

Priority: High Due date:  

Assignee:  % Done: 30%

Category: Portability Estimated time: 0.00 hour

Target version: CoCoALib-0.99900 Spent time: 2.25 hours

Description

Revise the source to use C++14 (and avoid "deprecated" features).

Related issues:

Related to CoCoALib - Feature #82: C++11 compatibility questions Closed 26 Jan 2012

Related to CoCoALib - Design #891: Replace auto_ptr in preparation for C++11? Closed 17 Jun 2016

Related to CoCoA-5 - Support #1240: John's visit Feb 2019 Closed 08 Feb 2019

Related to CoCoALib - Bug #1256: RingID: different values in test-output on d... Closed 15 Mar 2019

Related to CoCoALib - Design #1257: C++14: use nullptr Closed 18 Mar 2019

Related to CoCoALib - Design #1259: ThreadsafeCounter is now obsolete? Closed 25 Mar 2019

Related to CoCoALib - Design #710: Update normaliz interface? In Progress 17 May 2015

Related to CoCoALib - Feature #1218: 32-bit or 64-bit preprocessor macro? Closed 08 Aug 2018

Related to CoCoALib - Design #581: C++14: MachineInt Closed 04 Jul 2014

Related to CoCoA-5 - Feature #1305: Create a directory New 02 Sep 2019

Related to CoCoALib - Design #1242: C++14: Use type auto where appropriate In Progress 08 Feb 2019

Related to CoCoALib - Design #1346: C++14: use the new for loop syntax where ... In Progress 21 Oct 2019

Related to CoCoALib - Feature #142: Improve threadsafety In Progress 30 Apr 2012

Related to CoCoALib - Design #1446: Start using C++14 "move" capability In Progress 12 Mar 2020

Related to CoCoALib - Design #1511: Use C++14 constexpr Closed 14 Oct 2020

Related to CoCoA-5 - Design #1519: Interpreter fn Value::from can use std::move? New 26 Oct 2020

Related to CoCoA-5 - Design #1520: Replace BOOST_FOREACH by new C++14 range f... Closed 26 Oct 2020

Related to CoCoALib - Design #894: strict enum types: C++11 extension In Progress 21 Jun 2016

Related to CoCoALib - Design #1572: Use noexcept Resolved 29 Jan 2021

Related to CoCoALib - Design #1625: Use new C++ keyword override Closed 25 Oct 2021

Related to CoCoALib - Design #1627: Use keyword "delete" for deleted functions Closed 29 Oct 2021

Related to CoCoALib - Feature #1702: Use C++ attributes In Progress 18 Oct 2022

History

#1 - 06 Sep 2018 16:10 - John Abbott

Maintaining backward compatibility with pre-2011 C++ is probably fairly pointless, and is causing problems with users who want to use more recent

versions of C++.  Gereon reports that auto_ptr has been removed from C++17.

#2 - 06 Sep 2018 16:15 - John Abbott

- Related to Feature #82: C++11 compatibility questions added

#3 - 06 Sep 2018 16:17 - John Abbott

Here is a list of "upgrades" to make to our source:

make appropriate changes so that std::move can be used

(related to "move" above) change void fns which return single values via an OUT arg

[DONE] use atomic counters instead of ThreadsafeCounter (see #1259)

use auto type for some local variables (see issue #1242)

[DELEGATED] there is a new syntax for for loops with iterators (see issue #1346)

there are new machine integer types (investigate!)
https://cocoa.dima.unige.it/redmine/issues/1259
https://cocoa.dima.unige.it/redmine/issues/1242
https://cocoa.dima.unige.it/redmine/issues/1346


other???

[DONE] replace auto_ptr by unique_ptr (or whatever is appropriate)

[DONE] modify configure script, and replace auxiliary script cxx03.sh by cxx14.sh

[DONE] use nullptr instead of NULL or 0 (see #1257)

Note:  add new entries as we think of them (then tick them off)

#4 - 06 Sep 2018 16:54 - John Abbott

- Related to Design #891: Replace auto_ptr in preparation for C++11? added

#5 - 26 Feb 2019 16:17 - John Abbott

Check that the new configuration system works on several different platforms (incl. Microsoft???)

#6 - 04 Mar 2019 13:39 - Anna Maria Bigatti

- Related to Support #1240: John's visit Feb 2019 added

#7 - 05 Mar 2019 18:39 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 20

So far I have done the following:

revised and renamed script cxx03.sh into cxx14.sh

revised configure script accordingly

replaced auto_ptr by unique_ptr (somewhat blindly)

so far everything works fine on Anna's computer

#8 - 06 Mar 2019 18:16 - John Abbott

- % Done changed from 20 to 30

JAA has checked in latest changes.  Hope they work for Anna!

#9 - 11 Mar 2019 15:16 - Anna Maria Bigatti

John Abbott wrote:

JAA has checked in latest changes.  Hope they work for Anna!

 

whateve that was, it compiles and run the tests!

#10 - 15 Mar 2019 18:00 - John Abbott

- Related to Bug #1256: RingID: different values in test-output on different platforms added
#11 - 18 Mar 2019 11:29 - John Abbott

- Related to Design #1257: C++14: use nullptr added

#12 - 25 Mar 2019 12:02 - John Abbott

- Related to Design #1259: ThreadsafeCounter is now obsolete? added

#13 - 25 Mar 2019 15:34 - John Abbott

- Related to Design #710: Update normaliz interface? added

#14 - 05 Apr 2019 15:47 - John Abbott

- Related to Feature #1218: 32-bit or 64-bit preprocessor macro? added

#15 - 05 Apr 2019 16:06 - John Abbott

- Related to Design #581: C++14: MachineInt added

#16 - 02 Sep 2019 15:56 - Anna Maria Bigatti

- Related to Feature #1305: Create a directory added

#17 - 18 Oct 2019 11:15 - John Abbott

- Related to Design #1242: C++14: Use type auto where appropriate added

#18 - 21 Oct 2019 12:26 - John Abbott

- Related to Design #1346: C++14: use the new for loop syntax where appropriate (like cocoa's foreach) added

#19 - 22 Oct 2019 12:05 - John Abbott

- Related to Feature #142: Improve threadsafety added

#20 - 12 Mar 2020 14:44 - John Abbott

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99850

#21 - 12 Mar 2020 14:46 - John Abbott

- Related to Design #1446: Start using C++14 "move" capability added

#22 - 14 Oct 2020 21:51 - John Abbott

- Related to Design #1511: Use C++14 constexpr added

#23 - 26 Oct 2020 09:55 - John Abbott

- Related to Design #1519: Interpreter fn Value::from can use std::move? added

#24 - 26 Oct 2020 10:05 - John Abbott

- Related to Design #1520: Replace BOOST_FOREACH by new C++14 range for syntax added

#25 - 28 Oct 2020 23:20 - John Abbott

- Related to Design #894: strict enum types: C++11 extension added

#26 - 29 Jan 2021 20:18 - John Abbott

- Related to Design #1572: Use noexcept added

#27 - 25 Oct 2021 19:53 - John Abbott

- Related to Design #1625: Use new C++ keyword override added
#28 - 29 Oct 2021 21:50 - John Abbott

- Related to Design #1627: Use keyword "delete" for deleted functions added

#29 - 18 Oct 2022 20:57 - John Abbott

- Related to Feature #1702: Use C++ attributes added

#30 - 08 Mar 2024 17:46 - John Abbott

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99900

Powered by TCPDF (www.tcpdf.org)

28 Apr 2024 4/4

http://www.tcpdf.org

